%if 0%{?fedora} || 0%{?rhel} >= 7
%bcond_with python2
%bcond_without python3
%global python3_pkgversion 36
%else
%bcond_without python2
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%endif

%define srcname oci-cli
%define oci_cli_version 2.12.9
%define oci_sdk_version 2.21.2
%define cx_Oracle_version 7.0

Name: python-oci-cli
Version: %{oci_cli_version}
Release: 1.0.1%{?dist}
Url: http://pypi.python.org/pypi/%{srcname}
Summary: Oracle Cloud Infrastructure CLI client
License: Apache2.0
Group: Development/Libraries
SOURCE0: %{srcname}-%{version}.tar.gz
SOURCE1: %{srcname}-%{version}.zip
PATCH0: create_backup_from_onprem.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}

BuildArch: noarch

%if %{with python2}
BuildRequires: python2-devel
BuildRequires: python-setuptools

#required by OCI-CLI:
Requires: python-oci-sdk == %{oci_sdk_version}
Requires: python-click == 6.7
Requires: python-terminaltables == 3.1.0
Requires: python-retrying == 1.3.3
Requires: python2-arrow == 0.14.7
Requires: python2-jmespath == 0.10.0
Requires: pyOpenSSL == 18.0.0
Requires: PyYAML == 5.1.2
Requires: pytz >= 2016.10
Requires: python-configparser == 4.0.2 
#Other missing packages are provided by python-oci-sdk.

provides: python2-%{srcname} = %version-%release
%endif

%description
Python SDK for Oracle Cloud Infrastructure command line client utilities.

%if %{with python3}
%package -n python%{python3_pkgversion}-%{srcname}
Summary: %summary

BuildRequires: python%{python3_pkgversion}-devel
BuildRequires: python%{python3_pkgversion}-setuptools

#required by OCI-CLI:
Requires: python%{python3_pkgversion}-oci-sdk == %{oci_sdk_version}
Requires: python%{python3_pkgversion}-click == 6.7
Requires: python%{python3_pkgversion}-terminaltables == 3.1.0
Requires: python%{python3_pkgversion}-retrying == 1.3.3
Requires: python%{python3_pkgversion}-arrow == 0.14.7
Requires: python%{python3_pkgversion}-jmespath == 0.10.0
Requires: python%{python3_pkgversion}-pyOpenSSL == 18.0.0
Requires: python%{python3_pkgversion}-pyyaml == 5.1.2
Requires: python%{python3_pkgversion}-pytz >= 2016.10
Requires: python%{python3_pkgversion}-configparser == 4.0.2 
#Other missing requires  are provided by python-oci-sdk.
# cryptograph, idna, dateutil, six etc.

Provides: python3-oci-cli = %{version}-%{release}
Obsoletes: python-oci-cli

%description -n python%{python3_pkgversion}-%{srcname}
Python SDK for Oracle Cloud Infrastructure command line client utilities.
%endif

%prep
%setup -q -n %{srcname}-%{version}
unzip %{SOURCE1}
mv oci-cli/oci_cli_docs docs
mkdir examples
mv services/*/examples_and_test_scripts/* examples/ -n

%build
%if %{with python2}
%{__python2} setup.py build
%endif

%if %{with python3}
%{__python3} setup.py build
%endif

%install
%if %{with python2}
%{__python2} setup.py install -O1 --prefix=%{_prefix} --root=%{buildroot}
%endif

%if %{with python3}
%{__python3} setup.py install -O1 --prefix=%{_prefix} --root=%{buildroot}
%endif

sed 5i"import oci" -i %{buildroot}/usr/bin/oci
sed "s/<version>/%{cx_Oracle_version}/" -i %{PATCH0}
patch -p1 -F1 --no-backup-if-mismatch -i %{PATCH0} %{buildroot}/usr/bin/create_backup_from_onprem

%clean
rm -rf %{buildroot}

%if %{with python2}
%files
%defattr(-,root,root)
%{_bindir}/*
%{python2_sitelib}/*
%doc README.rst LICENSE.txt THIRD_PARTY_LICENSES.txt CHANGELOG.rst docs/ examples/
%endif

%if %{with python3}
%files -n python%{python3_pkgversion}-%{srcname}
%defattr(-,root,root)
%{_bindir}/*
%{python3_sitelib}/*
%doc README.rst LICENSE.txt THIRD_PARTY_LICENSES.txt CHANGELOG.rst docs/ examples/
%endif

%changelog
* Tue Sep 08 2020 Alan Steinberg <alan.steinberg@oracle.com> 2.12.9-1.0.1
- Fixed the runtime dependency for jmespath to 0.10.0. [Orabug: 31858712]

* Tue Sep 01 2020 EL Errata <el-errata_ww@oracle.com> 2.12.9-1
- Update to version 2.12.9

* Tue Aug 18 2020 EL Errata <el-errata_ww@oracle.com> 2.12.8-1
- Update to version 2.12.8

* Wed Aug 12 2020 Qing Lin <qing.lin@oracle.com> 2.12.7-1.0.1
- Fix the dependencies' conflict issues during yum update. [Orabug: 31747983]

* Tue Aug 11 2020 EL Errata <el-errata_ww@oracle.com> 2.12.7-1
- Update to version 2.12.7

* Tue Aug 04 2020 EL Errata <el-errata_ww@oracle.com> 2.12.6-1
- Update to version 2.12.6

* Tue Jul 28 2020 EL Errata <el-errata_ww@oracle.com> 2.12.5-1
- Update to version 2.12.5

* Tue Jul 21 2020 EL Errata <el-errata_ww@oracle.com> 2.12.4-1
- Update to version 2.12.4

* Tue Jul 14 2020 EL Errata <el-errata_ww@oracle.com> 2.12.3-1
- Update to version 2.12.3

* Tue Jul 07 2020 EL Errata <el-errata_ww@oracle.com> 2.12.2-1
- Update to version 2.12.2

* Tue Jun 30 2020 EL Errata <el-errata_ww@oracle.com> 2.12.1-1
- Update to version 2.12.1

* Tue Jun 23 2020 EL Errata <el-errata_ww@oracle.com> 2.12.0-1
- Update to version 2.12.0

* Thu Jun 18 2020 EL Errata <el-errata_ww@oracle.com> 2.11.1-1
- Update to version 2.11.1

* Tue Jun 09 2020 EL Errata <el-errata_ww@oracle.com> 2.11.0-1
- Update to version 2.11.0

* Tue Jun 03 2020 Qing Lin <qing.lin@oracle.com> 2.10.5-1.0.1
-  Added docs and examples for this package [Orabug: 31449070]

* Tue Jun 02 2020 EL Errata <el-errata_ww@oracle.com> 2.10.5-1
- Update to version 2.10.5

* Tue May 19 2020 EL Errata <el-errata_ww@oracle.com> 2.10.4-1
- Update to version 2.10.4

* Tue May 12 2020 EL Errata <el-errata_ww@oracle.com> 2.10.3-1
- Update to version 2.10.3

* Tue May 05 2020 EL Errata <el-errata_ww@oracle.com> 2.10.2-1
- Update to version 2.10.2

* Tue Apr 28 2020 EL Errata <el-errata_ww@oracle.com> 2.10.1-1
- Update to version 2.10.1

* Tue Apr 21 2020 EL Errata <el-errata_ww@oracle.com> 2.10.0-1
- Update to version 2.10.0

* Tue Apr 14 2020 EL Errata <el-errata_ww@oracle.com> 2.9.11-1
- Update to version 2.9.11

* Thu Apr 09 2020 EL Errata <el-errata_ww@oracle.com> 2.9.10-1
- Update to version 2.9.10

* Wed Apr 01 2020 EL Errata <el-errata_ww@oracle.com> 2.9.9-1
- Update to version 2.9.9

* Tue Mar 24 2020 EL Errata <el-errata_ww@oracle.com> 2.9.8-1
- Update to version 2.9.8

* Tue Mar 17 2020 EL Errata <el-errata_ww@oracle.com> 2.9.7-1
- Update to version 2.9.7

* Tue Mar 10 2020 EL Errata <el-errata_ww@oracle.com> 2.9.6-1
- Update to version 2.9.6

* Wed Mar 04 2020 Qing Lin <qing.lin@oracle.com> 2.9.5-1
- Update to version 2.9.5
- Update dependency arrow to 0.14.7 as oci cli required.
- Update dependency jmespath to 0.9.4 as oci cli required.
- Update dependency dateutil and pytz as oci cli required.

* Tue Mar 03 2020 Qing Lin <qing.lin@oracle.com> 2.9.4-1.0.2
- Added option to make sure "create_backup_from_onprem.orig" will not be generated. [Orabug: 30975227] 
- Added comments about the missing dependencies. [Orabug: 30775258]
- Added the required version for cx_Oracle in create_backup_from_onprem. [Orabug: 30975456]

* Wed Feb 26 2020 Qing Lin <qing.lin@oracle.com> 2.9.4-1.0.1
- Merged back PATCH0, which fixed bug-30915962 [Orabug: 30956095]
- Merged back changelog from 2.9.3-1.0.3. [Orabug: 30956060]
- Merged back python3 build.  [Orabug: 30955986]

* Tue Feb 25 2020 EL Errata <el-errata_ww@oracle.com> 2.9.4-1
- Update to version 2.9.4

* Tue Feb 25 2020 Qing Lin <qing.lin@oracle.com> 2.9.3-1.0.3
- Use patch instead of text file. Reviewed.

* Wed Feb 19 2020 Qing Lin <qing.lin@oracle.com> 2.9.3-1.0.2
- Remove cx_Oracle as dependency. [Orabug: 30915962]
- Update create_backup_from_onprem to notify user for the missing cx_Oracle package.

* Wed Feb 19 2020 EL Errata <el-errata_ww@oracle.com> 2.9.3-1.0.1
- Fix merge.

* Tue Feb 18 2020 EL Errata <el-errata_ww@oracle.com> 2.9.3-1
- Update to version 2.9.3

* Wed Feb 12 2020 John Mcwalters <john.mcwalters@oracle.com> 2.9.2-1.0.1
- Fix merge.

* Tue Feb 11 2020 EL Errata <el-errata_ww@oracle.com> 2.9.2-1
- Update to version 2.9.2

* Wed Feb 05 2020 Qing Lin <Qing.lin@oracle.com> 2.9.1-1.0.1
- Python2 oci cli is no longer needed. Obsolete it.

* Tue Feb 04 2020 EL Errata <el-errata_ww@oracle.com> 2.9.1-1
- Update to version 2.9.1

* Tue Jan 28 2020 Qing Lin <Qing.lin@oracle.com> 2.9.0-1.0.1
- Seperate python2 and python3 oci-cli commands.
- Change the Buildrequires and requires to exactly what oci asked.
- Ol7 build for both python2 and python3.
- Added a missing dependency: python-dateutil

* Tue Jan 28 2020 EL Errata <el-errata_ww@oracle.com> 2.9.0-1
- Update to version 2.9.0

* Wed Jan 22 2020 EL Errata <el-errata_ww@oracle.com> 2.8.2-1
- Update to version 2.8.2

* Tue Jan 14 2020 Jingdong Lu <jingdong.lu@oracle.com> 2.8.1-1
- Update to version 2.8.1

* Wed Jan 08 2020 Jingdong Lu <jingdong.lu@oracle.com> 2.8.0-1
- Update to version 2.8.0

* Tue Dec 17 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.7.0-1
- Update to version 2.7.0

* Tue Dec 10 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.15-1
- Update to version 2.6.15

* Tue Nov 26 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.14-1
- Update to version 2.6.14

* Tue Nov 19 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.13-1
- Update to version 2.6.13

* Wed Nov 13 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.12-1
- Update to version 2.6.12

* Tue Nov 05 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.11-1
- Update to version 2.6.11

* Tue Oct 29 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.10-1
- Update to version 2.6.10

* Wed Oct 16 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.9-1
- Update to version 2.6.9

* Tue Oct 08 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.8-1
- Update to version 2.6.8

* Tue Oct 01 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.7-1
- Update to version 2.6.7

* Tue Sep 24 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.6-1
- Update to version 2.6.6

* Tue Sep 17 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.5-1
- Update to version 2.6.5

* Tue Sep 10 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.4-1
- Update to version 2.6.4

* Tue Sep 03 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.3-1
- Update to version 2.6.3

* Tue Aug 27 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.2-1
- Update to version 2.6.2

* Tue Aug 20 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.1-1
- Update to version 2.6.1

* Tue Aug 13 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.6.0-1
- Update to version 2.6.0

* Tue Aug 06 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.22-1
- Update to version 2.5.22

* Tue Jul 30 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.21-1
- Update to version 2.5.21

* Tue Jul 23 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.20-1
- Update to version 2.5.20

* Tue Jul 16 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.19-1
- Update to version 2.5.19

* Tue Jul 09 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.18-1
- Update to version 2.5.18

* Wed Jul 03 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.17-1.0.1
- Add services/*

* Tue Jul 02 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.17-1
- Update to version 2.5.17

* Tue Jun 25 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.16-1
- Update to version 2.5.16

* Tue Jun 18 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.15-1
- Update to version 2.5.15

* Tue Jun 11 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.14-1
- Update to version 2.5.14

* Tue Jun 04 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.13-1
- Update to version 2.5.13

* Tue May 28 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.12-1
- Update to version 2.5.12

* Tue May 21 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.11-1
- Update to version 2.5.11

* Tue May 14 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.10-1
- Update to version 2.5.10

* Tue Apr 16 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.8-1
- Update to version 2.5.8

* Tue Apr 09 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.7-1
- Update to version 2.5.7

* Tue Apr 02 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.6-1
- Update to version 2.5.6

* Tue Mar 26 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.5-1
- Update to version 2.5.5

* Tue Mar 19 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.4-1
- Update to version 2.5.4

* Tue Mar 12 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.3-1
- Update to version 2.5.3

* Thu Feb 28 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.2-1
- Update to version 2.5.2

* Thu Feb 21 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.5.1-1
- Update to version 2.5.1

* Sun Feb 10 2019 Srinivas Maturi <srinivas.matruri@oracle.com> 2.4.44-1.0.2
- Updated dependency for python-cx_Oracle

* Fri Feb 08 2019 John Mcwalters <john.mcwalters@oracle.com> 2.4.44-1.0.1
- Changed Requires: PyYAML == 3.13

* Fri Feb 08 2019 John Mcwalters <john.mcwalters@oracle.com> 2.4.44-1
- Update to version 2.4.44

* Fri Feb 01 2019 Alan Steinberg <alan.steinberg@oracle.com> 2.4.43-1.0.1
- Update to version 2.4.43
- Changed Requires: pyOpenSSL == 18.0.0

* Thu Jan 31 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.4.43-1
- Update to version 2.4.43

* Wed Jan 30 2019 Qing Lin <qing.lin@oracle.com> 2.4.42-2
- Changed Requires: pyOpenSSL == 18.0.0 and python-cx_Oracle >= 7.0

* Thu Jan 24 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.4.42-1
- Update to version 2.4.42

* Mon Jan 14 2019 Jingdong Lu <jingdong.lu@oracle.com> 2.4.41-1
- Update to version 2.4.41

* Thu Dec 13 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.40-1.0.1
- Add Requires: pyOpenSSL == 17.5.0

* Thu Dec 13 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.40-1
- Update to version 2.4.40

* Thu Nov 29 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.39-1
- Update to version 2.4.39

* Thu Nov 15 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.38-1
- Update to version 2.4.38

* Thu Nov 01 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.37-1
- Update to version 2.4.37

* Mon Oct 29 2018 Alan Steinberg <alan.steinberg@oracle.com> 2.4.36-1.0.1
- Added explicit dependency on python-cx_Oracle
- Reviewed-by: john.mcwalters@oracle.com

* Fri Oct 26 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.36-1
- Update to version 2.4.36

* Thu Oct 18 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.35-1
- Update to version 2.4.35

* Thu Oct 04 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.34-1
- Update to version 2.4.34

* Thu Sep 27 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.33-1
- Update to version 2.4.33

* Thu Sep 06 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.32-1
- Update to version 2.4.32

* Thu Aug 23 2018 John Mcwalters <john.mcwcalters@oracle.com> 2.4.31-1
- Update to version 2.4.31

* Thu Aug 09 2018 Jacob Wang <jacob.wang@oracle.com> 2.4.30-1.0.1
- Remove dependency of pyOpenSSL

* Thu Aug 09 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.30-1
- Update to version 2.4.30

* Thu Jul 26 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.29-1
- Update to version 2.4.29

* Thu Jul 12 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.28-1
- Update to version 2.4.28

* Fri Jun 29 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.27-1
- Update to version 2.4.27

* Fri Jun 15 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.26-1
- Update to version 2.4.26

* Fri Jun 01 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.24-1
- Update to version 2.4.24

* Thu May 17 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.23-1
- Update to version 2.4.23

* Fri May 04 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.22-1
- Update to version 2.4.22

* Thu Apr 19 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.21-1
- Update to version 2.4.21

* Fri Apr 06 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.20-1
- Update to version 2.4.20

* Mon Mar 26 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.19-1
- Update to version 2.4.19

* Thu Mar 08 2018 Jingdong Lu <jingdong.lu@oracle.com> 2.4.18-1
- Update to version 2.4.18

* Fri Feb  23 2018 Qing Lin <qing.lin@oracle.com> - 2.4.17-1
- Updated python-oci-sdk dependency

* Fri Feb  9 2018 Qing Lin <qing.lin@oracle.com> - 2.4.16-2
- Updated python-oci-sdk dependency

* Fri Feb  9 2018 Qing Lin <qing.lin@oracle.com> - 2.4.16-1
- Upgraded to 2.4.15

* Fri Jan 26 2018 Qing Lin <qing.lin@oracle.com> - 2.4.15-1
- Upgraded to 2.4.15

* Mon Oct 16 2017 Qing Lin <qing.lin@oracle.com>
- Added the missing dependent package:python-retrying in spec file.
* Fri Sep 29 2017 Qing Lin <qing.lin@oracle.com>
- complete the dependencies list in  spec file for oci-cli 2.4.9
* Thu Aug 31 2017 Qing Lin <qing.lin@oracle.com>
- update for  spec file for oci-cli 2.4.7
- remove bmcs SDK package from CLI.
* Mon Jun 12 2017 Laszlo (Laca) Peter <laszlo.peter@oracle.com>
- initial spec file for oraclebmc-cli 2.4.4
